// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>

wchar_t comments[][100] = 
{
    L"Win32 heap info",
    L"Win32 heap info",
    L"Ptr to next CRT heap block (allocated earlier in time)",
    L"Ptr to prev CRT heap block (allocated later in time)",
    L"Filename of malloc() call",
    L"Line number of malloc() call",
    L"Number of bytes to malloc()",
    L"Type (0=Freed, 1=Normal, 2=CRT use, etc)",
    L"Request #, increases from 0",
    L"No mans land",
};

wchar_t *bytesYouWanted = L"The 8 bytes you wanted";
wchar_t *noMansLand = L"No mans land";
wchar_t *heapRoundUp = L"Win32 heap allocations are rounded up to 16 bytes";
wchar_t *bookKeeping = L"Win32 heap bookkepping";

void OutputHeap(LPVOID pVoid, bool showOnlyHeader)
{
    DWORD *pData = (DWORD *)pVoid;

    for (int i = -10; i < 0; i++)
    {
        DWORD value = *(pData + i);
        printf("offset: %03d(at 0x%08x) == 0x%08x [%S]\n", i * 4, (pData + i), value, comments[i + 10]);
    }

    printf("\n");

    if (showOnlyHeader == true)
    {
        return;
    }

    DWORD numberOfBytesToMalloc = *(DWORD *)((BYTE *)pVoid - 16);
    DWORD dataLen = numberOfBytesToMalloc / sizeof(LPVOID);

    for (int i = 0; i < dataLen; i++)
    {
        DWORD value = *(pData + i);
        printf("offset: %03d(at 0x%08x) == 0x%08x [%S]\n", i * 4, (pData + i), value, bytesYouWanted);
    }

    printf("\n");

    for (int i = dataLen; i < (dataLen + 1); i++)
    {
        DWORD value = *(pData + i);
        printf("offset: %03d(at 0x%08x) == 0x%08x [%S]\n", i * 4, (pData + i), value, noMansLand);
    }

    printf("\n");

    int bytes16Aligend = 4 - ((numberOfBytesToMalloc + 4) % 16) / 4;
    int mallocLen = (dataLen + 1 + bytes16Aligend);

    for (int i = dataLen + 1; i < mallocLen; i++)
    {
        DWORD value = *(pData + i);
        printf("offset: %03d(at 0x%08x) == 0x%08x [%S]\n", i * 4, (pData + i), value, heapRoundUp);
    }

    printf("\n");

    for (int i = mallocLen; i < (mallocLen + 8); i++)
    {
        DWORD value = *(pData + i);
        printf("offset: %03d(at 0x%08x) == 0x%08x [%S]\n", i * 4, (pData + i), value, bookKeeping);
    }

    printf("\n");
}

int main()
{
    //printf("========== GetProcessHeap + HeapAlloc =========\n");
    //{
    //    HANDLE hHeap = GetProcessHeap();
    //    LPVOID pVoid = HeapAlloc(hHeap, 0, 8);

    //    OutputHeap(pVoid);
    //}

    //printf("========== HeapCreate + HeapAlloc ========= \n");

    //{
    //    HANDLE hHeap = HeapCreate(0, 1024, 1024);
    //    LPVOID pVoid = HeapAlloc(hHeap, 0, 8);

    //    OutputHeap(pVoid);
    //}

    printf("========== malloc ========= \n");

    {
        LPVOID pVoid = malloc(8);
        OutputHeap(pVoid, false);

        LPVOID ptrToNext = (LPVOID)*((DWORD *)((BYTE *)pVoid - 32));

        printf("========== ptrToNext 0x%x ========= \n", ptrToNext);
        OutputHeap((BYTE *)ptrToNext + 32, true);
    }

    return 0;
}

